"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reverse = void 0;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Every boolean algebras has a dual algebra, which involves reversing one/zero as well as join/meet.
 *
 * @category combinators
 * @since 3.0.0
 */
var reverse = function (BA) { return ({
    meet: BA.join,
    join: BA.meet,
    zero: BA.one,
    one: BA.zero,
    implies: function (second) { return function (first) { return BA.join(second)(BA.not(first)); }; },
    not: BA.not
}); };
exports.reverse = reverse;
