"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.separate = exports.compact = exports.separateDefault = exports.compactDefault = void 0;
/**
 * `Compactable` represents data structures which can be _compacted_/_separated_.
 *
 * @since 3.0.0
 */
var Either_1 = require("./Either");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var Option_1 = require("./Option");
var Separated_1 = require("./Separated");
function compactDefault(F) {
    var fromOptionF = F.map(Either_1.fromOption(function_1.constVoid));
    return function (separate) { return function_1.flow(fromOptionF, separate, Separated_1.right); };
}
exports.compactDefault = compactDefault;
function separateDefault(F) {
    return function (compact) { return function (fe) { return Separated_1.separated(function_1.pipe(fe, F.map(Option_1.getLeft), compact), function_1.pipe(fe, F.map(Option_1.getRight), compact)); }; };
}
exports.separateDefault = separateDefault;
function compact(F, G) {
    return F.map(G.compact);
}
exports.compact = compact;
function separate(F, C, G) {
    var _compact = compact(F, C);
    var _map = Functor_1.map(F, G);
    return function (fge) { return Separated_1.separated(function_1.pipe(fge, _map(Option_1.getLeft), _compact), function_1.pipe(fge, _map(Option_1.getRight), _compact)); };
}
exports.separate = separate;
