"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bracket = exports.toUnion = exports.swap = exports.orElseFirst = exports.orLeft = exports.orElse = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.altValidation = exports.mapLeft = exports.bimap = exports.alt = exports.chain = exports.ap = exports.map = exports.chainNullableK = exports.fromNullableK = exports.fromNullable = exports.leftF = exports.rightF = exports.left = exports.right = void 0;
/**
 * @since 3.0.0
 */
var Apply_1 = require("./Apply");
var E = __importStar(require("./Either"));
var function_1 = require("./function");
var Functor_1 = require("./Functor");
function right(F) {
    return function_1.flow(E.right, F.of);
}
exports.right = right;
function left(F) {
    return function_1.flow(E.left, F.of);
}
exports.left = left;
function rightF(F) {
    return F.map(E.right);
}
exports.rightF = rightF;
function leftF(F) {
    return F.map(E.left);
}
exports.leftF = leftF;
function fromNullable(F) {
    return function (e) {
        return function_1.flow(E.fromNullable(function () { return e; }), F.of);
    };
}
exports.fromNullable = fromNullable;
function fromNullableK(F) {
    var fromNullableF = fromNullable(F);
    return function (e) {
        var fromNullableFE = fromNullableF(e);
        return function (f) { return function_1.flow(f, fromNullableFE); };
    };
}
exports.fromNullableK = fromNullableK;
function chainNullableK(M) {
    var chainM = chain(M);
    var fromNullableKM = fromNullableK(M);
    return function (e) {
        var fromNullableKMe = fromNullableKM(e);
        return function (f) { return chainM(fromNullableKMe(f)); };
    };
}
exports.chainNullableK = chainNullableK;
function map(F) {
    return Functor_1.map(F, E.Functor);
}
exports.map = map;
function ap(F) {
    return Apply_1.ap(F, E.Apply);
}
exports.ap = ap;
function chain(M) {
    return function (f) { return M.chain(function (e) { return (E.isLeft(e) ? M.of(e) : f(e.right)); }); };
}
exports.chain = chain;
function alt(M) {
    return function (second) { return M.chain(function (e) { return (E.isLeft(e) ? second() : M.of(e)); }); };
}
exports.alt = alt;
function bimap(F) {
    return function_1.flow(E.bimap, F.map);
}
exports.bimap = bimap;
function mapLeft(F) {
    return function (f) { return F.map(E.mapLeft(f)); };
}
exports.mapLeft = mapLeft;
function altValidation(M, S) {
    var rightM = right(M);
    return function (second) { return function (first) {
        return function_1.pipe(first, M.chain(E.match(function (e1) { return function_1.pipe(second(), M.map(E.mapLeft(function (e2) { return S.concat(e2)(e1); }))); }, rightM)));
    }; };
}
exports.altValidation = altValidation;
function match(F) {
    return function_1.flow(E.match, F.map);
}
exports.match = match;
function matchE(M) {
    return function_1.flow(E.match, M.chain);
}
exports.matchE = matchE;
function getOrElse(F) {
    return function_1.flow(E.getOrElse, F.map);
}
exports.getOrElse = getOrElse;
function getOrElseE(M) {
    return function (onLeft) { return M.chain(E.match(onLeft, M.of)); };
}
exports.getOrElseE = getOrElseE;
function orElse(M) {
    return function (onLeft) { return M.chain(function (e) { return (E.isLeft(e) ? onLeft(e.left) : M.of(e)); }); };
}
exports.orElse = orElse;
function orLeft(M) {
    return function (onLeft) {
        return M.chain(E.match(function (e) { return function_1.pipe(onLeft(e), M.map(E.left)); }, function (a) { return M.of(E.right(a)); }));
    };
}
exports.orLeft = orLeft;
function orElseFirst(M) {
    var orElseM = orElse(M);
    return function (onLeft) {
        return orElseM(function (e) {
            return function_1.pipe(onLeft(e), M.map(function (eb) { return (E.isLeft(eb) ? eb : E.left(e)); }));
        });
    };
}
exports.orElseFirst = orElseFirst;
function swap(F) {
    return F.map(E.swap);
}
exports.swap = swap;
function toUnion(F) {
    return F.map(E.toUnion);
}
exports.toUnion = toUnion;
function bracket(M) {
    var leftM = left(M);
    return function (acquire, use, release) {
        return function_1.pipe(acquire, M.chain(E.match(leftM, function (a) {
            return function_1.pipe(use(a), M.chain(function (e) { return function_1.pipe(release(a, e), M.chain(E.match(leftM, function () { return M.of(e); }))); }));
        })));
    };
}
exports.bracket = bracket;
