"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lcm = exports.gcd = void 0;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * The *greatest common divisor* of two values.
 *
 * @since 3.0.0
 */
var gcd = function (E, F) {
    var predicate = E.equals(F.zero);
    var f = function (second) { return function (first) { return (predicate(second) ? first : f(F.mod(second)(first))(second)); }; };
    return f;
};
exports.gcd = gcd;
/**
 * The *least common multiple* of two values.
 *
 * @since 3.0.0
 */
var lcm = function (E, F) {
    var zero = F.zero;
    var predicate = E.equals(zero);
    var gcdSF = exports.gcd(E, F);
    return function (second) { return function (first) {
        return predicate(first) || predicate(second) ? zero : F.div(gcdSF(second)(first))(F.mul(second)(first));
    }; };
};
exports.lcm = lcm;
