"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partitionMap = exports.partition = exports.filterMap = exports.filter = void 0;
var function_1 = require("./function");
var Option_1 = require("./Option");
var Predicate_1 = require("./Predicate");
var Separated_1 = require("./Separated");
function filter(F, G) {
    return function (predicate) { return F.map(G.filter(predicate)); };
}
exports.filter = filter;
function filterMap(F, G) {
    return function_1.flow(G.filterMap, F.map);
}
exports.filterMap = filterMap;
function partition(F, G) {
    var _filter = filter(F, G);
    return function (predicate) {
        var left = _filter(Predicate_1.not(predicate));
        var right = _filter(predicate);
        return function (fga) { return Separated_1.separated(left(fga), right(fga)); };
    };
}
exports.partition = partition;
function partitionMap(F, G) {
    var _filterMap = filterMap(F, G);
    return function (f) { return function (fga) { return Separated_1.separated(function_1.pipe(fga, _filterMap(function_1.flow(f, Option_1.getLeft))), function_1.pipe(fga, _filterMap(function_1.flow(f, Option_1.getRight)))); }; };
}
exports.partitionMap = partitionMap;
