"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toReadonlyArray = exports.intercalate = exports.reduceE = exports.reduceRight = exports.foldMap = exports.reduce = void 0;
var function_1 = require("./function");
function reduce(F, G) {
    return function (b, f) { return F.reduce(b, function (b, ga) { return G.reduce(b, f)(ga); }); };
}
exports.reduce = reduce;
function foldMap(F, G) {
    return function (M) { return function_1.flow(G.foldMap(M), F.foldMap(M)); };
}
exports.foldMap = foldMap;
function reduceRight(F, G) {
    return function (b, f) { return F.reduceRight(b, function (ga, b) { return G.reduceRight(b, f)(ga); }); };
}
exports.reduceRight = reduceRight;
function reduceE(F) {
    return function (M) { return function (mb, f) {
        return F.reduce(mb, function (mb, a) {
            return function_1.pipe(mb, M.chain(function (b) { return f(b, a); }));
        });
    }; };
}
exports.reduceE = reduceE;
function intercalate(F) {
    return function (M) { return function (sep) { return function (fm) {
        var go = function (_a, m) {
            var init = _a[0], acc = _a[1];
            return init ? [false, m] : [false, function_1.pipe(acc, M.concat(sep), M.concat(m))];
        };
        return function_1.pipe(fm, F.reduce([true, M.empty], go))[1];
    }; }; };
}
exports.intercalate = intercalate;
function toReadonlyArray(F) {
    return function (fa) {
        return function_1.pipe(fa, F.reduce([], function (acc, a) {
            acc.push(a);
            return acc;
        }));
    };
}
exports.toReadonlyArray = toReadonlyArray;
