"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEmpty = exports.size = exports.getDifferenceMagma = exports.getIntersectionSemigroup = exports.getUnionMonoid = exports.getUnionSemigroup = exports.getWitherable = exports.wilt = exports.wither = exports.getTraversableWithIndex = exports.traverseWithIndex = exports.getTraversable = exports.traverse = exports.getFoldableWithIndex = exports.reduceRightWithIndex = exports.foldMapWithIndex = exports.reduceWithIndex = exports.getFoldable = exports.reduceRight = exports.foldMap = exports.reduce = exports.getFilterableWithIndex = exports.Filterable = exports.Compactable = exports.getFunctorWithIndex = exports.flap = exports.Functor = exports.getMonoid = exports.getEq = exports.getShow = exports.partitionMapWithIndex = exports.partitionWithIndex = exports.filterMapWithIndex = exports.filterWithIndex = exports.partitionMap = exports.partition = exports.filterMap = exports.filter = exports.separate = exports.compact = exports.mapWithIndex = exports.map = exports.pop = exports.deleteAt = exports.modifyAt = exports.updateAt = exports.upsertAt = exports.insertAt = exports.fromFoldable = exports.singleton = void 0;
exports.difference = exports.intersection = exports.union = exports.toUnfoldable = exports.toReadonlyArray = exports.empty = exports.isSubmap = exports.lookup = exports.lookupWithKey = exports.collect = exports.values = exports.keys = exports.elem = exports.member = void 0;
var Eq_1 = require("./Eq");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
var O = __importStar(require("./Option"));
var Separated_1 = require("./Separated");
var Tuple2_1 = require("./Tuple2");
var Witherable_1 = require("./Witherable");
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * Create a `ReadonlyMap` from one key/value pair.
 *
 * @category constructors
 * @since 3.0.0
 */
var singleton = function (k, a) { return new Map([[k, a]]); };
exports.singleton = singleton;
function fromFoldable(F) {
    return function (E, M) {
        var lookupWithKeyE = exports.lookupWithKey(E);
        return function (f) {
            return F.reduce(new Map(), function (out, a) {
                var _a = f(a), k = _a[0], b = _a[1];
                var oka = lookupWithKeyE(k)(out);
                if (_.isSome(oka)) {
                    out.set(oka.value[0], M.concat(b)(oka.value[1]));
                }
                else {
                    out.set(k, b);
                }
                return out;
            });
        };
    };
}
exports.fromFoldable = fromFoldable;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Insert an element at the specified key, creating a new `ReadonlyMap`, or returning `None` if the key already exists.
 *
 * @category combinators
 * @since 3.0.0
 */
var insertAt = function (E) {
    var memberE = exports.member(E);
    var upsertAtE = exports.upsertAt(E);
    return function (k, a) {
        var memberEk = memberE(k);
        var upsertAtEka = upsertAtE(k, a);
        return function (m) { return (memberEk(m) ? _.none : _.some(upsertAtEka(m))); };
    };
};
exports.insertAt = insertAt;
/**
 * Insert or replace a key/value pair in a `ReadonlyMap`.
 *
 * @category combinators
 * @since 3.0.0
 */
var upsertAt = function (E) {
    var lookupWithKeyE = exports.lookupWithKey(E);
    return function (k, a) {
        var lookupWithKeyEk = lookupWithKeyE(k);
        return function (m) {
            var found = lookupWithKeyEk(m);
            if (_.isNone(found)) {
                var out = new Map(m);
                out.set(k, a);
                return out;
            }
            else if (found.value[1] !== a) {
                var out = new Map(m);
                out.set(found.value[0], a);
                return out;
            }
            return m;
        };
    };
};
exports.upsertAt = upsertAt;
/**
 * Change the element at the specified keys, creating a new `ReadonlyMap`, or returning `None` if the key doesn't exist.
 *
 * @since 3.0.0
 */
var updateAt = function (E) {
    var modifyAtE = exports.modifyAt(E);
    return function (k, a) { return modifyAtE(k, function () { return a; }); };
};
exports.updateAt = updateAt;
/**
 * Apply a function to the element at the specified key, creating a new `ReadonlyMap`, or returning `None` if the key doesn't exist.
 *
 * @since 3.0.0
 */
var modifyAt = function (E) {
    var lookupWithKeyE = exports.lookupWithKey(E);
    return function (k, f) {
        var lookupWithKeyEk = lookupWithKeyE(k);
        return function (m) {
            var found = lookupWithKeyEk(m);
            if (_.isNone(found)) {
                return _.none;
            }
            var _a = found.value, fk = _a[0], fv = _a[1];
            var next = f(fv);
            if (next === fv) {
                return _.some(m);
            }
            var r = new Map(m);
            r.set(fk, next);
            return _.some(r);
        };
    };
};
exports.modifyAt = modifyAt;
/**
 * Delete the element at the specified key, creating a new `ReadonlyMap`, or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var deleteAt = function (E) {
    var popE = exports.pop(E);
    return function (k) { return function_1.flow(popE(k), O.map(Tuple2_1.snd)); };
};
exports.deleteAt = deleteAt;
/**
 * Delete a key and value from a `ReadonlyMap`, returning the value as well as the subsequent `ReadonlyMap`,
 * or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var pop = function (E) {
    var lookupWithKeyE = exports.lookupWithKey(E);
    return function (k) {
        var lookupWithKeyEk = lookupWithKeyE(k);
        return function (m) {
            var found = lookupWithKeyEk(m);
            return function_1.pipe(found, O.map(function (_a) {
                var k = _a[0], a = _a[1];
                var out = new Map(m);
                out.delete(k);
                return [a, out];
            }));
        };
    };
};
exports.pop = pop;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 3.0.0
 */
var map = function (f) { return exports.mapWithIndex(function (_, a) { return f(a); }); };
exports.map = map;
/**
 * @category FunctorWithIndex
 * @since 3.0.0
 */
var mapWithIndex = function (f) { return function (m) {
    var out = new Map();
    var entries = m.entries();
    var e;
    while (!(e = entries.next()).done) {
        var _a = e.value, key = _a[0], a = _a[1];
        out.set(key, f(key, a));
    }
    return out;
}; };
exports.mapWithIndex = mapWithIndex;
/**
 * @category Compactable
 * @since 3.0.0
 */
var compact = function (m) {
    var out = new Map();
    var entries = m.entries();
    var e;
    while (!(e = entries.next()).done) {
        var _a = e.value, k = _a[0], oa = _a[1];
        if (_.isSome(oa)) {
            out.set(k, oa.value);
        }
    }
    return out;
};
exports.compact = compact;
/**
 * @category Compactable
 * @since 3.0.0
 */
var separate = function (fa) {
    var left = new Map();
    var right = new Map();
    var entries = fa.entries();
    var e;
    while (!(e = entries.next()).done) {
        var _a = e.value, k = _a[0], ei = _a[1];
        if (_.isLeft(ei)) {
            left.set(k, ei.left);
        }
        else {
            right.set(k, ei.right);
        }
    }
    return Separated_1.separated(left, right);
};
exports.separate = separate;
/**
 * @category Filterable
 * @since 3.0.0
 */
var filter = function (predicate) { return function (fa) {
    return function_1.pipe(fa, filterWithIndex(function (_, a) { return predicate(a); }));
}; };
exports.filter = filter;
/**
 * @category Filterable
 * @since 3.0.0
 */
var filterMap = function (f) { return exports.filterMapWithIndex(function (_, a) { return f(a); }); };
exports.filterMap = filterMap;
/**
 * @category Filterable
 * @since 3.0.0
 */
var partition = function (predicate) { return function (fa) {
    return function_1.pipe(fa, partitionWithIndex(function (_, a) { return predicate(a); }));
}; };
exports.partition = partition;
/**
 * @category Filterable
 * @since 3.0.0
 */
var partitionMap = function (f) { return exports.partitionMapWithIndex(function (_, a) { return f(a); }); };
exports.partitionMap = partitionMap;
function filterWithIndex(predicateWithIndex) {
    return function (m) {
        var out = new Map();
        var entries = m.entries();
        var e;
        // tslint:disable-next-line: strict-boolean-expressions
        while (!(e = entries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            if (predicateWithIndex(k, a)) {
                out.set(k, a);
            }
        }
        return out;
    };
}
exports.filterWithIndex = filterWithIndex;
/**
 * @category FilterableWithIndex
 * @since 3.0.0
 */
var filterMapWithIndex = function (f) { return function (fa) {
    var m = new Map();
    var entries = fa.entries();
    var e;
    while (!(e = entries.next()).done) {
        var _a = e.value, k = _a[0], a = _a[1];
        var o = f(k, a);
        if (_.isSome(o)) {
            m.set(k, o.value);
        }
    }
    return m;
}; };
exports.filterMapWithIndex = filterMapWithIndex;
function partitionWithIndex(predicateWithIndex) {
    return function (m) {
        var left = new Map();
        var right = new Map();
        var entries = m.entries();
        var e;
        // tslint:disable-next-line: strict-boolean-expressions
        while (!(e = entries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            if (predicateWithIndex(k, a)) {
                right.set(k, a);
            }
            else {
                left.set(k, a);
            }
        }
        return Separated_1.separated(left, right);
    };
}
exports.partitionWithIndex = partitionWithIndex;
/**
 * @category FilterableWithIndex
 * @since 3.0.0
 */
var partitionMapWithIndex = function (f) { return function (fa) {
    var left = new Map();
    var right = new Map();
    var entries = fa.entries();
    var e;
    while (!(e = entries.next()).done) {
        var _a = e.value, k = _a[0], a = _a[1];
        var ei = f(k, a);
        if (_.isLeft(ei)) {
            left.set(k, ei.left);
        }
        else {
            right.set(k, ei.right);
        }
    }
    return Separated_1.separated(left, right);
}; };
exports.partitionMapWithIndex = partitionMapWithIndex;
/**
 * @category instances
 * @since 3.0.0
 */
var getShow = function (SK, SA) { return ({
    show: function (m) {
        var entries = [];
        m.forEach(function (a, k) {
            entries.push("[" + SK.show(k) + ", " + SA.show(a) + "]");
        });
        return "new Map([" + entries.sort().join(', ') + "])";
    }
}); };
exports.getShow = getShow;
/**
 * @category instances
 * @since 3.0.0
 */
var getEq = function (EK, EA) {
    var isSubmapSKSA = exports.isSubmap(EK, EA);
    return Eq_1.fromEquals(function (second) { return function (first) { return isSubmapSKSA(first)(second) && isSubmapSKSA(second)(first); }; });
};
exports.getEq = getEq;
/**
 * Get a `Monoid` instance for `ReadonlyMap` given a `Semigroup` instance for its values.
 *
 * @category instances
 * @since 3.0.0
 */
var getMonoid = function (EK, SA) {
    var lookupWithKeyS = exports.lookupWithKey(EK);
    return {
        concat: function (second) { return function (first) {
            if (exports.isEmpty(first)) {
                return second;
            }
            if (exports.isEmpty(second)) {
                return first;
            }
            var r = new Map(first);
            var entries = second.entries();
            var e;
            while (!(e = entries.next()).done) {
                var _a = e.value, k = _a[0], a = _a[1];
                var oka = lookupWithKeyS(k)(first);
                if (_.isSome(oka)) {
                    r.set(oka.value[0], SA.concat(a)(oka.value[1]));
                }
                else {
                    r.set(k, a);
                }
            }
            return r;
        }; },
        empty: exports.empty
    };
};
exports.getMonoid = getMonoid;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/
Functor_1.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getFunctorWithIndex = function () { return ({
    mapWithIndex: exports.mapWithIndex
}); };
exports.getFunctorWithIndex = getFunctorWithIndex;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Compactable = {
    compact: exports.compact,
    separate: exports.separate
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Filterable = {
    partitionMap: exports.partitionMap,
    partition: exports.partition,
    filterMap: exports.filterMap,
    filter: exports.filter
};
/**
 * @category instances
 * @since 3.0.0
 */
var getFilterableWithIndex = function () { return ({
    filterWithIndex: filterWithIndex,
    filterMapWithIndex: exports.filterMapWithIndex,
    partitionWithIndex: partitionWithIndex,
    partitionMapWithIndex: exports.partitionMapWithIndex
}); };
exports.getFilterableWithIndex = getFilterableWithIndex;
/**
 * @since 3.0.0
 */
var reduce = function (O) {
    var reduceWithIndexO = exports.reduceWithIndex(O);
    return function (b, f) { return reduceWithIndexO(b, function (_, b, a) { return f(b, a); }); };
};
exports.reduce = reduce;
/**
 * @since 3.0.0
 */
var foldMap = function (O) {
    var foldMapWithIndexO = exports.foldMapWithIndex(O);
    return function (M) {
        var foldMapWithIndexOM = foldMapWithIndexO(M);
        return function (f) { return foldMapWithIndexOM(function (_, a) { return f(a); }); };
    };
};
exports.foldMap = foldMap;
/**
 * @since 3.0.0
 */
var reduceRight = function (O) {
    var reduceRightWithIndexO = exports.reduceRightWithIndex(O);
    return function (b, f) { return reduceRightWithIndexO(b, function (_, b, a) { return f(b, a); }); };
};
exports.reduceRight = reduceRight;
/**
 * @category instances
 * @since 3.0.0
 */
var getFoldable = function (O) {
    return {
        reduce: exports.reduce(O),
        foldMap: exports.foldMap(O),
        reduceRight: exports.reduceRight(O)
    };
};
exports.getFoldable = getFoldable;
/**
 * @since 3.0.0
 */
var reduceWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (b, f) { return function (m) {
        var out = b;
        for (var _i = 0, _a = keysO(m); _i < _a.length; _i++) {
            var k = _a[_i];
            out = f(k, out, m.get(k));
        }
        return out;
    }; };
};
exports.reduceWithIndex = reduceWithIndex;
/**
 * @since 3.0.0
 */
var foldMapWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (M) { return function (f) { return function (m) {
        var out = M.empty;
        for (var _i = 0, _a = keysO(m); _i < _a.length; _i++) {
            var k = _a[_i];
            out = M.concat(f(k, m.get(k)))(out);
        }
        return out;
    }; }; };
};
exports.foldMapWithIndex = foldMapWithIndex;
/**
 * @since 3.0.0
 */
var reduceRightWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (b, f) { return function (m) {
        var out = b;
        var ks = keysO(m);
        var len = ks.length;
        for (var i = len - 1; i >= 0; i--) {
            var k = ks[i];
            out = f(k, m.get(k), out);
        }
        return out;
    }; };
};
exports.reduceRightWithIndex = reduceRightWithIndex;
/**
 * @category instances
 * @since 3.0.0
 */
var getFoldableWithIndex = function (O) {
    return {
        reduceWithIndex: exports.reduceWithIndex(O),
        foldMapWithIndex: exports.foldMapWithIndex(O),
        reduceRightWithIndex: exports.reduceRightWithIndex(O)
    };
};
exports.getFoldableWithIndex = getFoldableWithIndex;
/**
 * @since 3.0.0
 */
var traverse = function (O) {
    var traverseWithIndexO = exports.traverseWithIndex(O);
    return function (F) {
        var traverseWithIndexOF = traverseWithIndexO(F);
        return function (f) { return traverseWithIndexOF(function (_, a) { return f(a); }); };
    };
};
exports.traverse = traverse;
/**
 * @category instances
 * @since 3.0.0
 */
var getTraversable = function (O) {
    return {
        map: exports.map,
        traverse: exports.traverse(O)
    };
};
exports.getTraversable = getTraversable;
/**
 * @since 3.0.0
 */
var traverseWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (F) { return function (f) { return function (ta) {
        var fm = F.of(new Map());
        var _loop_1 = function (k) {
            var a = ta.get(k);
            fm = function_1.pipe(fm, F.map(function (m) { return function (b) { return m.set(k, b); }; }), F.ap(f(k, a)));
        };
        for (var _i = 0, _a = keysO(ta); _i < _a.length; _i++) {
            var k = _a[_i];
            _loop_1(k);
        }
        return fm;
    }; }; };
};
exports.traverseWithIndex = traverseWithIndex;
/**
 * @category instances
 * @since 3.0.0
 */
var getTraversableWithIndex = function (O) {
    return {
        traverseWithIndex: exports.traverseWithIndex(O)
    };
};
exports.getTraversableWithIndex = getTraversableWithIndex;
/**
 * @since 3.0.0
 */
var wither = function (O) {
    return Witherable_1.witherDefault(exports.getTraversable(O), exports.Compactable);
};
exports.wither = wither;
/**
 * @since 3.0.0
 */
var wilt = function (O) {
    return Witherable_1.wiltDefault(exports.getTraversable(O), exports.Compactable);
};
exports.wilt = wilt;
/**
 * @category instances
 * @since 3.0.0
 */
var getWitherable = function (O) {
    return {
        wither: exports.wither(O),
        wilt: exports.wilt(O)
    };
};
exports.getWitherable = getWitherable;
/**
 * @category instances
 * @since 3.0.0
 */
var getUnionSemigroup = function (E, S) { return ({
    concat: exports.union(E, S)
}); };
exports.getUnionSemigroup = getUnionSemigroup;
/**
 * @category instances
 * @since 3.0.0
 */
var getUnionMonoid = function (E, S) { return ({
    concat: exports.getUnionSemigroup(E, S).concat,
    empty: exports.empty
}); };
exports.getUnionMonoid = getUnionMonoid;
/**
 * @category instances
 * @since 3.0.0
 */
var getIntersectionSemigroup = function (E, S) { return ({
    concat: exports.intersection(E, S)
}); };
exports.getIntersectionSemigroup = getIntersectionSemigroup;
/**
 * @category combinator
 * @since 3.0.0
 */
var getDifferenceMagma = function (E) { return function () { return ({
    concat: exports.difference(E)
}); }; };
exports.getDifferenceMagma = getDifferenceMagma;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Calculate the number of key/value pairs in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var size = function (d) { return d.size; };
exports.size = size;
/**
 * Test whether or not a `ReadonlyMap` is empty.
 *
 * @since 3.0.0
 */
var isEmpty = function (d) { return d.size === 0; };
exports.isEmpty = isEmpty;
/**
 * Test whether or not a key exists in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var member = function (E) {
    var lookupE = exports.lookup(E);
    return function (k) {
        var lookupEk = lookupE(k);
        return function (m) { return _.isSome(lookupEk(m)); };
    };
};
exports.member = member;
/**
 * Tests whether a value is a member of a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var elem = function (E) { return function (a) {
    var predicate = E.equals(a);
    return function (m) {
        var values = m.values();
        var e;
        while (!(e = values.next()).done) {
            var v = e.value;
            if (predicate(v)) {
                return true;
            }
        }
        return false;
    };
}; };
exports.elem = elem;
/**
 * Get a sorted `ReadonlyArray` of the keys contained in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var keys = function (O) { return function (m) {
    return Array.from(m.keys()).sort(function (first, second) { return O.compare(second)(first); });
}; };
exports.keys = keys;
/**
 * Get a sorted `ReadonlyArray` of the values contained in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var values = function (O) { return function (m) {
    return Array.from(m.values()).sort(function (first, second) { return O.compare(second)(first); });
}; };
exports.values = values;
/**
 * @since 3.0.0
 */
var collect = function (O) {
    var keysO = exports.keys(O);
    return function (f) { return function (m) {
        var out = [];
        var ks = keysO(m);
        for (var _i = 0, ks_1 = ks; _i < ks_1.length; _i++) {
            var key = ks_1[_i];
            out.push(f(key, m.get(key)));
        }
        return out;
    }; };
};
exports.collect = collect;
/**
 * Lookup the value for a key in a `ReadonlyMap`.
 * If the result is a `Some`, the existing key is also returned.
 *
 * @since 3.0.0
 */
var lookupWithKey = function (E) { return function (k) {
    var predicate = E.equals(k);
    return function (m) {
        var entries = m.entries();
        var e;
        while (!(e = entries.next()).done) {
            var _a = e.value, k_1 = _a[0], a = _a[1];
            if (predicate(k_1)) {
                return _.some([k_1, a]);
            }
        }
        return _.none;
    };
}; };
exports.lookupWithKey = lookupWithKey;
/**
 * Lookup the value for a key in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var lookup = function (E) {
    var lookupWithKeyE = exports.lookupWithKey(E);
    return function (k) { return function_1.flow(lookupWithKeyE(k), O.map(Tuple2_1.snd)); };
};
exports.lookup = lookup;
/**
 * Test whether or not one `ReadonlyMap` contains all of the keys and values contained in another `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var isSubmap = function (EK, SA) {
    var lookupWithKeyS = exports.lookupWithKey(EK);
    return function (second) { return function (first) {
        var entries = first.entries();
        var e;
        while (!(e = entries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            var oka = lookupWithKeyS(k)(second);
            if (_.isNone(oka) || !EK.equals(oka.value[0])(k) || !SA.equals(oka.value[1])(a)) {
                return false;
            }
        }
        return true;
    }; };
};
exports.isSubmap = isSubmap;
/**
 * An empty `ReadonlyMap`.
 *
 * @since 3.0.0
 */
exports.empty = new Map();
/**
 * Get a sorted `ReadonlyArray` of the key/value pairs contained in a `ReadonlyMap`.
 *
 * @since 3.0.0
 */
var toReadonlyArray = function (O) {
    return exports.collect(O)(function (k, a) { return [k, a]; });
};
exports.toReadonlyArray = toReadonlyArray;
function toUnfoldable(U) {
    return function (o) {
        var toReadonlyArrayO = exports.toReadonlyArray(o);
        return function (m) {
            var arr = toReadonlyArrayO(m);
            var len = arr.length;
            return U.unfold(0, function (b) { return (b < len ? _.some([arr[b], b + 1]) : _.none); });
        };
    };
}
exports.toUnfoldable = toUnfoldable;
/**
 * @since 3.0.0
 */
var union = function (E, M) {
    var lookupE = exports.lookup(E);
    return function (second) { return function (first) {
        if (exports.isEmpty(first)) {
            return second;
        }
        if (exports.isEmpty(second)) {
            return first;
        }
        var out = new Map();
        var firstEntries = first.entries();
        var e;
        while (!(e = firstEntries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            var oka = lookupE(k)(second);
            if (_.isSome(oka)) {
                out.set(k, M.concat(oka.value)(a));
            }
            else {
                out.set(k, a);
            }
        }
        var secondEntries = second.entries();
        while (!(e = secondEntries.next()).done) {
            var _b = e.value, k = _b[0], a = _b[1];
            var oka = lookupE(k)(out);
            if (_.isNone(oka)) {
                out.set(k, a);
            }
        }
        return out;
    }; };
};
exports.union = union;
/**
 * @since 3.0.0
 */
var intersection = function (E, M) {
    var lookupE = exports.lookup(E);
    return function (second) { return function (first) {
        if (exports.isEmpty(first) || exports.isEmpty(second)) {
            return exports.empty;
        }
        var out = new Map();
        var entries = first.entries();
        var e;
        while (!(e = entries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            var oka = lookupE(k)(second);
            if (_.isSome(oka)) {
                out.set(k, M.concat(oka.value)(a));
            }
        }
        return out;
    }; };
};
exports.intersection = intersection;
/**
 * @since 3.0.0
 */
var difference = function (E) {
    var memberE = exports.member(E);
    return function (second) { return function (first) {
        if (exports.isEmpty(first)) {
            return second;
        }
        if (exports.isEmpty(second)) {
            return first;
        }
        var out = new Map();
        var firstEntries = first.entries();
        var e;
        while (!(e = firstEntries.next()).done) {
            var _a = e.value, k = _a[0], a = _a[1];
            if (!memberE(k)(second)) {
                out.set(k, a);
            }
        }
        var secondEntries = second.entries();
        while (!(e = secondEntries.next()).done) {
            var _b = e.value, k = _b[0], a = _b[1];
            if (!memberE(k)(first)) {
                out.set(k, a);
            }
        }
        return out;
    }; };
};
exports.difference = difference;
