"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.size = exports.getDifferenceMagma = exports.getIntersectionSemigroup = exports.getUnionMonoid = exports.getUnionSemigroup = exports.getWitherable = exports.wilt = exports.wither = exports.getTraversableWithIndex = exports.getTraversable = exports.FilterableWithIndex = exports.Filterable = exports.Compactable = exports.getFoldableWithIndex = exports.getFoldable = exports.FunctorWithIndex = exports.flap = exports.Functor = exports.getMonoid = exports.getEq = exports.getShow = exports.separate = exports.compact = exports.reduceRight = exports.foldMap = exports.reduce = exports.partitionMap = exports.partition = exports.filterMap = exports.filter = exports.filterWithIndex = exports.filterMapWithIndex = exports.partitionWithIndex = exports.partitionMapWithIndex = exports.traverse = exports.traverseWithIndex = exports.reduceRightWithIndex = exports.foldMapWithIndex = exports.reduceWithIndex = exports.keys = exports.mapWithIndex = exports.map = exports.pop = exports.deleteAt = exports.modifyAt = exports.updateAt = exports.upsertAt = exports.insertAt = exports.fromFoldable = exports.singleton = void 0;
exports.fromEntries = exports.toEntries = exports.difference = exports.intersection = exports.union = exports.elem = exports.some = exports.every = exports.empty = exports.lookup = exports.isSubrecord = exports.has = exports.toUnfoldable = exports.toReadonlyArray = exports.collect = exports.isEmpty = void 0;
var Eq_1 = require("./Eq");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
var O = __importStar(require("./Option"));
var Separated_1 = require("./Separated");
var Witherable_1 = require("./Witherable");
var S = __importStar(require("./string"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * Create a `ReadonlyRecord` from one key/value pair.
 *
 * @category constructors
 * @since 3.0.0
 */
var singleton = function (k, a) {
    var _a;
    return (_a = {}, _a[k] = a, _a);
};
exports.singleton = singleton;
function fromFoldable(F) {
    return function (M) { return function (f) {
        return F.reduce({}, function (r, a) {
            var _a = f(a), k = _a[0], b = _a[1];
            r[k] = _.has.call(r, k) ? M.concat(b)(r[k]) : b;
            return r;
        });
    }; };
}
exports.fromFoldable = fromFoldable;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Insert an element at the specified key, creating a new `ReadonlyRecord`, or returning `None` if the key already exists.
 *
 * @category combinators
 * @since 3.0.0
 */
var insertAt = function (k, a) { return function (r) {
    if (!_.has.call(r, k)) {
        var out = Object.assign({}, r);
        out[k] = a;
        return _.some(out);
    }
    return _.none;
}; };
exports.insertAt = insertAt;
/**
 * Insert or replace a key/value pair in a `ReadonlyRecord`.
 *
 * @category combinators
 * @since 3.0.0
 */
var upsertAt = function (k, a) { return function (r) {
    if (_.has.call(r, k) && r[k] === a) {
        return r;
    }
    var out = Object.assign({}, r);
    out[k] = a;
    return out;
}; };
exports.upsertAt = upsertAt;
/**
 * Change the element at the specified keys, creating a new `ReadonlyRecord`, or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var updateAt = function (k, a) {
    return exports.modifyAt(k, function () { return a; });
};
exports.updateAt = updateAt;
/**
 * Apply a function to the element at the specified key, creating a new `ReadonlyRecord`, or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var modifyAt = function (k, f) { return function (r) {
    if (!exports.has(k, r)) {
        return _.none;
    }
    var a = f(r[k]);
    if (a === r[k]) {
        return _.some(r);
    }
    var out = Object.assign({}, r);
    out[k] = a;
    return _.some(out);
}; };
exports.modifyAt = modifyAt;
/**
 * Delete the element at the specified key, creating a new `ReadonlyRecord`, or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var deleteAt = function (k) { return function (r) {
    if (!_.has.call(r, k)) {
        return _.none;
    }
    var out = Object.assign({}, r);
    delete out[k];
    return _.some(out);
}; };
exports.deleteAt = deleteAt;
/**
 * Delete the element at the specified key, returning the value as well as the subsequent `ReadonlyRecord`,
 * or returning `None` if the key doesn't exist.
 *
 * @category combinators
 * @since 3.0.0
 */
var pop = function (k) { return function (r) {
    return function_1.pipe(r, exports.deleteAt(k), O.map(function (out) { return [r[k], out]; }));
}; };
exports.pop = pop;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Map a `ReadonlyRecord` passing the values to the iterating function.
 *
 * @category Functor
 * @since 3.0.0
 */
var map = function (f) {
    return mapWithIndex(function (_, a) { return f(a); });
};
exports.map = map;
function mapWithIndex(f) {
    return function (r) {
        var out = {};
        for (var k in r) {
            if (_.has.call(r, k)) {
                out[k] = f(k, r[k]);
            }
        }
        return out;
    };
}
exports.mapWithIndex = mapWithIndex;
/**
 * @since 3.0.0
 */
var keys = function (O) { return function (r) {
    return Object.keys(r).sort(function (first, second) { return O.compare(second)(first); });
}; };
exports.keys = keys;
/**
 * @since 3.0.0
 */
var reduceWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (b, f) { return function (r) {
        var out = b;
        for (var _i = 0, _a = keysO(r); _i < _a.length; _i++) {
            var k = _a[_i];
            out = f(k, out, r[k]);
        }
        return out;
    }; };
};
exports.reduceWithIndex = reduceWithIndex;
/**
 * @since 3.0.0
 */
var foldMapWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (M) { return function (f) { return function (r) {
        var out = M.empty;
        for (var _i = 0, _a = keysO(r); _i < _a.length; _i++) {
            var k = _a[_i];
            out = M.concat(f(k, r[k]))(out);
        }
        return out;
    }; }; };
};
exports.foldMapWithIndex = foldMapWithIndex;
/**
 * @since 3.0.0
 */
var reduceRightWithIndex = function (O) {
    var keysO = exports.keys(O);
    return function (b, f) { return function (r) {
        var out = b;
        var ks = keysO(r);
        var len = ks.length;
        for (var i = len - 1; i >= 0; i--) {
            var k = ks[i];
            out = f(k, r[k], out);
        }
        return out;
    }; };
};
exports.reduceRightWithIndex = reduceRightWithIndex;
function traverseWithIndex(O) {
    var keysO = exports.keys(O);
    return function (F) { return function (f) { return function (ta) {
        if (exports.isEmpty(ta)) {
            return F.of(exports.empty);
        }
        var out = F.of({});
        var _loop_1 = function (key) {
            out = function_1.pipe(out, F.map(function (r) { return function (b) {
                var _a;
                return Object.assign({}, r, (_a = {}, _a[key] = b, _a));
            }; }), F.ap(f(key, ta[key])));
        };
        for (var _i = 0, _a = keysO(ta); _i < _a.length; _i++) {
            var key = _a[_i];
            _loop_1(key);
        }
        return out;
    }; }; };
}
exports.traverseWithIndex = traverseWithIndex;
function traverse(O) {
    var traverseWithIndexO = traverseWithIndex(O);
    return function (F) {
        var traverseWithIndexOF = traverseWithIndexO(F);
        return function (f) { return traverseWithIndexOF(function (_, a) { return f(a); }); };
    };
}
exports.traverse = traverse;
/**
 * @category FilterableWithIndex
 * @since 3.0.0
 */
function partitionMapWithIndex(f) {
    return function (r) {
        var left = {};
        var right = {};
        for (var k in r) {
            if (_.has.call(r, k)) {
                var e = f(k, r[k]);
                if (_.isLeft(e)) {
                    left[k] = e.left;
                }
                else {
                    right[k] = e.right;
                }
            }
        }
        return Separated_1.separated(left, right);
    };
}
exports.partitionMapWithIndex = partitionMapWithIndex;
function partitionWithIndex(predicateWithIndex) {
    return function (r) {
        var left = {};
        var right = {};
        for (var k in r) {
            if (_.has.call(r, k)) {
                var a = r[k];
                if (predicateWithIndex(k, a)) {
                    right[k] = a;
                }
                else {
                    left[k] = a;
                }
            }
        }
        return Separated_1.separated(left, right);
    };
}
exports.partitionWithIndex = partitionWithIndex;
function filterMapWithIndex(f) {
    return function (r) {
        var out = {};
        for (var k in r) {
            if (_.has.call(r, k)) {
                var ob = f(k, r[k]);
                if (_.isSome(ob)) {
                    out[k] = ob.value;
                }
            }
        }
        return out;
    };
}
exports.filterMapWithIndex = filterMapWithIndex;
function filterWithIndex(predicateWithIndex) {
    return function (r) {
        var out = {};
        var changed = false;
        for (var key in r) {
            if (_.has.call(r, key)) {
                var a = r[key];
                if (predicateWithIndex(key, a)) {
                    out[key] = a;
                }
                else {
                    changed = true;
                }
            }
        }
        return changed ? out : r;
    };
}
exports.filterWithIndex = filterWithIndex;
/**
 * @category Filterable
 * @since 3.0.0
 */
var filter = function (predicate) { return filterWithIndex(function (_, a) { return predicate(a); }); };
exports.filter = filter;
/**
 * @category Filterable
 * @since 3.0.0
 */
var filterMap = function (f) { return filterMapWithIndex(function (_, a) { return f(a); }); };
exports.filterMap = filterMap;
/**
 * @category Filterable
 * @since 3.0.0
 */
var partition = function (predicate) {
    return partitionWithIndex(function (_, a) { return predicate(a); });
};
exports.partition = partition;
/**
 * @category Filterable
 * @since 3.0.0
 */
var partitionMap = function (f) { return partitionMapWithIndex(function (_, a) { return f(a); }); };
exports.partitionMap = partitionMap;
/**
 * @since 3.0.0
 */
var reduce = function (O) {
    var reduceWithIndexO = exports.reduceWithIndex(O);
    return function (b, f) { return reduceWithIndexO(b, function (_, b, a) { return f(b, a); }); };
};
exports.reduce = reduce;
/**
 * @since 3.0.0
 */
var foldMap = function (O) {
    var foldMapWithIndexO = exports.foldMapWithIndex(O);
    return function (M) {
        var foldMapWithIndexOM = foldMapWithIndexO(M);
        return function (f) { return foldMapWithIndexOM(function (_, a) { return f(a); }); };
    };
};
exports.foldMap = foldMap;
/**
 * @category Foldable
 * @since 3.0.0
 */
var reduceRight = function (O) {
    var reduceRightWithIndexO = exports.reduceRightWithIndex(O);
    return function (b, f) { return reduceRightWithIndexO(b, function (_, b, a) { return f(b, a); }); };
};
exports.reduceRight = reduceRight;
/**
 * @category Compactable
 * @since 3.0.0
 */
var compact = function (r) {
    var out = {};
    for (var k in r) {
        if (_.has.call(r, k)) {
            var oa = r[k];
            if (_.isSome(oa)) {
                out[k] = oa.value;
            }
        }
    }
    return out;
};
exports.compact = compact;
/**
 * @category Compactable
 * @since 3.0.0
 */
var separate = function (r) {
    var left = {};
    var right = {};
    for (var k in r) {
        if (_.has.call(r, k)) {
            var e = r[k];
            if (_.isLeft(e)) {
                left[k] = e.left;
            }
            else {
                right[k] = e.right;
            }
        }
    }
    return Separated_1.separated(left, right);
};
exports.separate = separate;
/**
 * @category instances
 * @since 3.0.0
 */
var getShow = function (O) {
    var collectO = exports.collect(O);
    return function (S) {
        var f = collectO(function (k, a) { return JSON.stringify(k) + ": " + S.show(a); });
        return {
            show: function (r) {
                var elements = f(r).join(', ');
                return elements === '' ? '{}' : "{ " + elements + " }";
            }
        };
    };
};
exports.getShow = getShow;
/**
 * @category instances
 * @since 3.0.0
 */
function getEq(E) {
    var isSubrecordE = exports.isSubrecord(E);
    return Eq_1.fromEquals(function (second) { return function (first) { return isSubrecordE(first)(second) && isSubrecordE(second)(first); }; });
}
exports.getEq = getEq;
function getMonoid(S) {
    return {
        concat: function (second) { return function (first) {
            if (exports.isEmpty(first)) {
                return second;
            }
            if (exports.isEmpty(second)) {
                return first;
            }
            var r = Object.assign({}, first);
            for (var k in second) {
                if (_.has.call(second, k)) {
                    r[k] = _.has.call(first, k) ? S.concat(second[k])(first[k]) : second[k];
                }
            }
            return r;
        }; },
        empty: exports.empty
    };
}
exports.getMonoid = getMonoid;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/
Functor_1.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FunctorWithIndex = {
    mapWithIndex: mapWithIndex
};
/**
 * @category instances
 * @since 3.0.0
 */
var getFoldable = function (O) { return ({
    reduce: exports.reduce(O),
    foldMap: exports.foldMap(O),
    reduceRight: exports.reduceRight(O)
}); };
exports.getFoldable = getFoldable;
/**
 * @category instances
 * @since 3.0.0
 */
var getFoldableWithIndex = function (O) { return ({
    reduceWithIndex: exports.reduceWithIndex(O),
    foldMapWithIndex: exports.foldMapWithIndex(O),
    reduceRightWithIndex: exports.reduceRightWithIndex(O)
}); };
exports.getFoldableWithIndex = getFoldableWithIndex;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Compactable = {
    compact: exports.compact,
    separate: exports.separate
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Filterable = {
    filter: exports.filter,
    filterMap: exports.filterMap,
    partition: exports.partition,
    partitionMap: exports.partitionMap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FilterableWithIndex = {
    filterMapWithIndex: filterMapWithIndex,
    filterWithIndex: filterWithIndex,
    partitionMapWithIndex: partitionMapWithIndex,
    partitionWithIndex: partitionWithIndex
};
/**
 * @category instances
 * @since 3.0.0
 */
var getTraversable = function (O) { return ({
    map: exports.map,
    traverse: traverse(O)
}); };
exports.getTraversable = getTraversable;
/**
 * @category instances
 * @since 3.0.0
 */
var getTraversableWithIndex = function (O) { return ({
    traverseWithIndex: traverseWithIndex(O)
}); };
exports.getTraversableWithIndex = getTraversableWithIndex;
/**
 * @category Witherable
 * @since 3.0.0
 */
var wither = function (O) { return Witherable_1.witherDefault(exports.getTraversable(O), exports.Compactable); };
exports.wither = wither;
/**
 * @category Witherable
 * @since 3.0.0
 */
var wilt = function (O) { return Witherable_1.wiltDefault(exports.getTraversable(O), exports.Compactable); };
exports.wilt = wilt;
/**
 * @category instances
 * @since 3.0.0
 */
var getWitherable = function (O) { return ({
    wither: exports.wither(O),
    wilt: exports.wilt(O)
}); };
exports.getWitherable = getWitherable;
/**
 * @category instances
 * @since 3.0.0
 */
var getUnionSemigroup = function (S) { return ({
    concat: exports.union(S)
}); };
exports.getUnionSemigroup = getUnionSemigroup;
/**
 * @category instances
 * @since 3.0.0
 */
var getUnionMonoid = function (S) { return ({
    concat: exports.getUnionSemigroup(S).concat,
    empty: exports.empty
}); };
exports.getUnionMonoid = getUnionMonoid;
/**
 * @category instances
 * @since 3.0.0
 */
var getIntersectionSemigroup = function (S) { return ({
    concat: exports.intersection(S)
}); };
exports.getIntersectionSemigroup = getIntersectionSemigroup;
/**
 * @category instances
 * @since 3.0.0
 */
var getDifferenceMagma = function () { return ({
    concat: exports.difference
}); };
exports.getDifferenceMagma = getDifferenceMagma;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Calculate the number of key/value pairs in a `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
var size = function (r) { return Object.keys(r).length; };
exports.size = size;
/**
 * Test whether a `ReadonlyRecord` is empty.
 *
 * @since 3.0.0
 */
var isEmpty = function (r) {
    for (var k in r) {
        if (_.has.call(r, k)) {
            return false;
        }
    }
    return true;
};
exports.isEmpty = isEmpty;
/**
 * Map a `ReadonlyRecord` into an `ReadonlyArray`.
 *
 * @example
 * import { collect } from 'fp-ts/ReadonlyRecord'
 * import * as S from 'fp-ts/string'
 *
 * const x: { a: string, b: boolean } = { a: 'foo', b: false }
 * assert.deepStrictEqual(
 *   collect(S.Ord)((key, val) => ({key: key, value: val}))(x),
 *   [{key: 'a', value: 'foo'}, {key: 'b', value: false}]
 * )
 *
 * @since 3.0.0
 */
var collect = function (O) {
    var keysO = exports.keys(O);
    return function (f) { return function (r) {
        var out = [];
        for (var _i = 0, _a = keysO(r); _i < _a.length; _i++) {
            var k = _a[_i];
            out.push(f(k, r[k]));
        }
        return out;
    }; };
};
exports.collect = collect;
/**
 * Get a sorted `ReadonlyArray` of the key/value pairs contained in a `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
var toReadonlyArray = function (O) { return exports.collect(O)(function (k, a) { return [k, a]; }); };
exports.toReadonlyArray = toReadonlyArray;
function toUnfoldable(O) {
    var toReadonlyArrayO = exports.toReadonlyArray(O);
    return function (U) { return function (r) {
        var as = toReadonlyArrayO(r);
        var len = as.length;
        return U.unfold(0, function (b) { return (b < len ? _.some([as[b], b + 1]) : _.none); });
    }; };
}
exports.toUnfoldable = toUnfoldable;
/**
 * Test whether or not a key exists in a `ReadonlyRecord`.
 *
 * Note. This function is not pipeable because is a custom type guard.
 *
 * @since 3.0.0
 */
var has = function (k, r) { return _.has.call(r, k); };
exports.has = has;
/**
 * Test whether one `ReadonlyRecord` contains all of the keys and values contained in another `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
var isSubrecord = function (E) { return function (second) { return function (first) {
    for (var k in first) {
        if (!_.has.call(second, k) || !E.equals(second[k])(first[k])) {
            return false;
        }
    }
    return true;
}; }; };
exports.isSubrecord = isSubrecord;
/**
 * Lookup the value for a key in a `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
var lookup = function (k) { return function (r) {
    return _.has.call(r, k) ? _.some(r[k]) : _.none;
}; };
exports.lookup = lookup;
/**
 * An empty `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
exports.empty = _.emptyRecord;
function every(predicate) {
    return function (r) {
        for (var k in r) {
            if (!predicate(r[k])) {
                return false;
            }
        }
        return true;
    };
}
exports.every = every;
/**
 * @since 3.0.0
 */
var some = function (predicate) { return function (r) {
    for (var k in r) {
        if (predicate(r[k])) {
            return true;
        }
    }
    return false;
}; };
exports.some = some;
/**
 * Tests whether a value is a member of a `ReadonlyRecord`.
 *
 * @since 3.0.0
 */
var elem = function (E) { return function (a) {
    var predicate = E.equals(a);
    return function (r) {
        for (var k in r) {
            if (predicate(r[k])) {
                return true;
            }
        }
        return false;
    };
}; };
exports.elem = elem;
/**
 * @since 3.0.0
 */
var union = function (M) { return function (second) { return function (first) {
    if (exports.isEmpty(first)) {
        return second;
    }
    if (exports.isEmpty(second)) {
        return first;
    }
    var out = {};
    for (var k in first) {
        if (exports.has(k, second)) {
            out[k] = M.concat(second[k])(first[k]);
        }
        else {
            out[k] = first[k];
        }
    }
    for (var k in second) {
        if (!exports.has(k, out)) {
            out[k] = second[k];
        }
    }
    return out;
}; }; };
exports.union = union;
/**
 * @since 3.0.0
 */
var intersection = function (M) { return function (second) { return function (first) {
    if (exports.isEmpty(first) || exports.isEmpty(second)) {
        return exports.empty;
    }
    var out = {};
    for (var k in first) {
        if (exports.has(k, second)) {
            out[k] = M.concat(second[k])(first[k]);
        }
    }
    return out;
}; }; };
exports.intersection = intersection;
/**
 * @since 3.0.0
 */
var difference = function (second) { return function (first) {
    if (exports.isEmpty(first)) {
        return second;
    }
    if (exports.isEmpty(second)) {
        return first;
    }
    var out = {};
    for (var k in first) {
        if (!exports.has(k, second)) {
            out[k] = first[k];
        }
    }
    for (var k in second) {
        if (!exports.has(k, first)) {
            out[k] = second[k];
        }
    }
    return out;
}; };
exports.difference = difference;
/**
 * Converts a `ReadonlyRecord` into a `ReadonlyArray` of `[key, value]` tuples.
 *
 * @example
 * import { toEntries } from 'fp-ts/ReadonlyRecord'
 *
 * assert.deepStrictEqual(toEntries({ a: 1, b: 2 }), [['a', 1], ['b', 2]])
 *
 * @since 3.0.0
 */
exports.toEntries = exports.toReadonlyArray(S.Ord);
/**
 * Converts a `ReadonlyArray` of `[key, value]` tuples into a `ReadonlyRecord`.
 *
 * @example
 * import { fromEntries } from 'fp-ts/ReadonlyRecord'
 *
 * assert.deepStrictEqual(fromEntries([['a', 1], ['b', 2], ['a', 3]]), { b: 2, a: 3 })
 *
 * @since 3.0.0
 */
var fromEntries = function (fa) {
    var out = {};
    for (var _i = 0, fa_1 = fa; _i < fa_1.length; _i++) {
        var a = fa_1[_i];
        out[a[0]] = a[1];
    }
    return out;
};
exports.fromEntries = fromEntries;
