"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getChainRec = exports.getMonad = exports.getChain = exports.getApplicative = exports.getApply = exports.getPointed = exports.Traversable = exports.Foldable = exports.Comonad = exports.Semigroupoid = exports.flap = exports.Functor = exports.mapFst = exports.Bifunctor = exports.traverse = exports.reduceRight = exports.foldMap = exports.reduce = exports.duplicate = exports.extract = exports.extend = exports.compose = exports.mapSnd = exports.bimap = exports.swap = exports.snd = exports.fst = exports.tuple2 = void 0;
var Bifunctor_1 = require("./Bifunctor");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var tuple2 = function (a, e) { return [a, e]; };
exports.tuple2 = tuple2;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var fst = function (t) { return t[0]; };
exports.fst = fst;
/**
 * @since 3.0.0
 */
var snd = function (t) { return t[1]; };
exports.snd = snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var swap = function (t) { return [exports.snd(t), exports.fst(t)]; };
exports.swap = swap;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
var bimap = function (mapSnd, mapFst) { return function (t) { return [
    mapFst(exports.fst(t)),
    mapSnd(exports.snd(t))
]; }; };
exports.bimap = bimap;
/**
 * Map a function over the second component of a `Tuple2`.
 *
 * This is the `mapLeft` operation of the `Bifunctor` instance.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapSnd = 
/*#__PURE__*/
Bifunctor_1.mapLeftDefault(exports.bimap);
/**
 * @category Semigroupoid
 * @since 3.0.0
 */
var compose = function (bc) { return function (ab) { return [exports.fst(bc), exports.snd(ab)]; }; };
exports.compose = compose;
/**
 * @category Extend
 * @since 3.0.0
 */
var extend = function (f) { return function (wa) { return [f(wa), exports.snd(wa)]; }; };
exports.extend = extend;
/**
 * @category Extract
 * @since 3.0.0
 */
exports.extract = exports.fst;
/**
 * Derivable from `Extend`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.duplicate = 
/*#__PURE__*/
exports.extend(function_1.identity);
/**
 * @category Foldable
 * @since 3.0.0
 */
var reduce = function (b, f) { return function (fa) { return f(b, exports.fst(fa)); }; };
exports.reduce = reduce;
/**
 * @category Foldable
 * @since 3.0.0
 */
var foldMap = function () { return function (f) { return function (fa) { return f(exports.fst(fa)); }; }; };
exports.foldMap = foldMap;
/**
 * @category Foldable
 * @since 3.0.0
 */
var reduceRight = function (b, f) { return function (fa) { return f(exports.fst(fa), b); }; };
exports.reduceRight = reduceRight;
/**
 * @since 3.0.0
 */
var traverse = function (F) { return function (f) { return function (t) {
    return function_1.pipe(f(exports.fst(t)), F.map(function (b) { return [b, exports.snd(t)]; }));
}; }; };
exports.traverse = traverse;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapSnd
};
/**
 * Map a function over the first component of a `Tuple2`.
 *
 * This is the `map` operation of the `Functor` instance.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.mapFst = 
/*#__PURE__*/
Bifunctor_1.map(exports.Bifunctor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.mapFst
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/
Functor_1.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Semigroupoid = {
    compose: exports.compose
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Comonad = {
    map: exports.mapFst,
    extend: exports.extend,
    extract: exports.extract
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Foldable = {
    reduce: exports.reduce,
    foldMap: exports.foldMap,
    reduceRight: exports.reduceRight
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Traversable = {
    map: exports.mapFst,
    traverse: exports.traverse
};
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: function (a) { return [a, M.empty]; }
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (S) { return ({
    map: exports.mapFst,
    ap: function (fa) { return function (fab) { return [exports.fst(fab)(exports.fst(fa)), S.concat(exports.snd(fa))(exports.snd(fab))]; }; }
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (M) {
    var A = exports.getApply(M);
    var P = exports.getPointed(M);
    return {
        map: exports.mapFst,
        ap: A.ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getChain = function (S) {
    return {
        map: exports.mapFst,
        chain: function (f) { return function (ma) {
            var _a = f(exports.fst(ma)), b = _a[0], s = _a[1];
            return [b, S.concat(s)(exports.snd(ma))];
        }; }
    };
};
exports.getChain = getChain;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = exports.getPointed(M);
    var C = exports.getChain(M);
    return {
        map: exports.mapFst,
        chain: C.chain,
        of: P.of
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
function getChainRec(M) {
    var chainRec = function (f) { return function (a) {
        var result = f(a);
        var acc = M.empty;
        var s = exports.fst(result);
        while (_.isLeft(s)) {
            acc = M.concat(exports.snd(result))(acc);
            result = f(s.left);
            s = exports.fst(result);
        }
        return [s.right, M.concat(exports.snd(result))(acc)];
    }; };
    return {
        chainRec: chainRec
    };
}
exports.getChainRec = getChainRec;
