// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Every boolean algebras has a dual algebra, which involves reversing one/zero as well as join/meet.
 *
 * @category combinators
 * @since 3.0.0
 */
export const reverse = (BA) => ({
    meet: BA.join,
    join: BA.meet,
    zero: BA.one,
    one: BA.zero,
    implies: (second) => (first) => BA.join(second)(BA.not(first)),
    not: BA.not
});
