import { flow, pipe } from './function';
import { getLeft, getRight } from './Option';
import { not } from './Predicate';
import { separated } from './Separated';
export function filter(F, G) {
    return (predicate) => F.map(G.filter(predicate));
}
export function filterMap(F, G) {
    return flow(G.filterMap, F.map);
}
export function partition(F, G) {
    const _filter = filter(F, G);
    return (predicate) => {
        const left = _filter(not(predicate));
        const right = _filter(predicate);
        return (fga) => separated(left(fga), right(fga));
    };
}
export function partitionMap(F, G) {
    const _filterMap = filterMap(F, G);
    return (f) => (fga) => separated(pipe(fga, _filterMap(flow(f, getLeft))), pipe(fga, _filterMap(flow(f, getRight))));
}
