import { flow, pipe } from './function';
export function reduce(F, G) {
    return (b, f) => F.reduce(b, (b, ga) => G.reduce(b, f)(ga));
}
export function foldMap(F, G) {
    return (M) => flow(G.foldMap(M), F.foldMap(M));
}
export function reduceRight(F, G) {
    return (b, f) => F.reduceRight(b, (ga, b) => G.reduceRight(b, f)(ga));
}
export function reduceE(F) {
    return (M) => (mb, f) => F.reduce(mb, (mb, a) => pipe(mb, M.chain((b) => f(b, a))));
}
export function intercalate(F) {
    return (M) => (sep) => (fm) => {
        const go = ([init, acc], m) => init ? [false, m] : [false, pipe(acc, M.concat(sep), M.concat(m))];
        return pipe(fm, F.reduce([true, M.empty], go))[1];
    };
}
export function toReadonlyArray(F) {
    return (fa) => pipe(fa, F.reduce([], (acc, a) => {
        acc.push(a);
        return acc;
    }));
}
