/**
 * Lift a computation from the `IO` monad.
 *
 * @since 3.0.0
 */
import { chainFirst } from './Chain';
import { flow } from './function';
export function fromIOK(F) {
    return (f) => flow(f, F.fromIO);
}
export function chainIOK(F, M) {
    return (f) => M.chain(flow(f, F.fromIO));
}
export function chainFirstIOK(F, M) {
    const chainFirstM = chainFirst(M);
    return (f) => chainFirstM(flow(f, F.fromIO));
}
