/**
 * Lift a computation from the `Reader` monad.
 *
 * @since 3.0.0
 */
import { chainFirst } from './Chain';
import { flow } from './function';
import * as R from './Reader';
export function ask(F) {
    return () => F.fromReader(R.ask());
}
export function asks(F) {
    return F.fromReader;
}
export function fromReaderK(F) {
    return (f) => flow(f, F.fromReader);
}
export function chainReaderK(F, M) {
    return flow(fromReaderK(F), M.chain);
}
export function chainFirstReaderK(F, M) {
    return flow(fromReaderK(F), chainFirst(M));
}
