/**
 * Lift a computation from the `Task` monad.
 *
 * @since 3.0.0
 */
import { chainFirst } from './Chain';
import { flow } from './function';
export function fromTaskK(F) {
    return (f) => flow(f, F.fromTask);
}
export function chainTaskK(F, M) {
    return (f) => M.chain(flow(f, F.fromTask));
}
export function chainFirstTaskK(F, M) {
    const chainFirstM = chainFirst(M);
    return (f) => chainFirstM(flow(f, F.fromTask));
}
