/**
 * @since 3.0.0
 */
import { ap as ap_ } from './Apply';
import { constant, flow } from './function';
import { map as map_ } from './Functor';
import * as _ from './internal';
import * as O from './Option';
export function some(F) {
    return flow(_.some, F.of);
}
export function zero(F) {
    return constant(F.of(_.none));
}
export function fromF(F) {
    return F.map(_.some);
}
export function fromNullable(F) {
    return flow(O.fromNullable, F.of);
}
export function fromNullableK(F) {
    const fromNullableF = fromNullable(F);
    return (f) => flow(f, fromNullableF);
}
export function fromOptionK(F) {
    return (f) => flow(f, F.of);
}
export function fromPredicate(F) {
    return (predicate) => (a) => F.of(O.fromPredicate(predicate)(a));
}
export function fromEither(F) {
    return flow(O.fromEither, F.of);
}
export function match(F) {
    return flow(O.match, F.map);
}
export function matchE(M) {
    return flow(O.match, M.chain);
}
export function getOrElse(F) {
    return flow(O.getOrElse, F.map);
}
export function getOrElseE(M) {
    return (onNone) => M.chain(O.match(onNone, M.of));
}
export function chainNullableK(M) {
    return flow(fromNullableK(M), chain(M));
}
export function chainOptionK(M) {
    return flow(fromOptionK(M), chain(M));
}
export function map(F) {
    return map_(F, O.Functor);
}
export function ap(F) {
    return ap_(F, O.Apply);
}
export function chain(M) {
    const zeroM = zero(M);
    return (f) => M.chain(O.match(() => zeroM(), f));
}
export function alt(M) {
    const _some = some(M);
    return (second) => M.chain(O.match(second, _some));
}
