import { constFalse, constTrue, flow } from './function';
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @category Contravariant
 * @since 3.0.0
 */
export const contramap = (f) => (predicate) => flow(f, predicate);
/**
 * @category instances
 * @since 3.0.0
 */
export const getSemigroupAny = () => ({
    concat: or
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getMonoidAny = () => ({
    concat: getSemigroupAny().concat,
    empty: constFalse
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getSemigroupAll = () => ({
    concat: and
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getMonoidAll = () => ({
    concat: getSemigroupAll().concat,
    empty: constTrue
});
/**
 * @category instances
 * @since 3.0.0
 */
export const Contravariant = {
    contramap
};
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
export const not = (predicate) => (a) => !predicate(a);
/**
 * @since 3.0.0
 */
export const or = (second) => (first) => (a) => first(a) || second(a);
/**
 * @since 3.0.0
 */
export const and = (second) => (first) => (a) => first(a) && second(a);
