import { flow, pipe } from './function';
import { snd } from './Tuple2';
export function of(F) {
    return (a) => (s) => F.of([a, s]);
}
export function map(F) {
    return (f) => (fa) => flow(fa, F.map(([a, s1]) => [f(a), s1]));
}
export function ap(M) {
    return (fa) => (fab) => (s) => pipe(fab(s), M.chain(([f, s]) => pipe(fa(s), M.map(([a, s]) => [f(a), s]))));
}
export function chain(M) {
    return (f) => (ma) => (s) => pipe(ma(s), M.chain(([a, s1]) => f(a)(s1)));
}
export function fromState(F) {
    return (sa) => (s) => F.of(sa(s));
}
export function fromF(F) {
    return (ma) => (s) => pipe(ma, F.map((a) => [a, s]));
}
export function evaluate(F) {
    return (s) => (ma) => pipe(ma(s), F.map(([a]) => a));
}
export function execute(F) {
    return (s) => (ma) => pipe(ma(s), F.map(snd));
}
