/**
 * @since 3.0.0
 */
import { ap as ap_ } from './Apply';
import { flow, pipe } from './function';
import { map as map_ } from './Functor';
import * as T from './These';
export function right(F) {
    return flow(T.right, F.of);
}
export function left(F) {
    return flow(T.left, F.of);
}
export function both(F) {
    return flow(T.both, F.of);
}
export function rightF(F) {
    return F.map(T.right);
}
export function leftF(F) {
    return F.map(T.left);
}
export function map(F) {
    return map_(F, T.Functor);
}
export function ap(F, S) {
    return ap_(F, T.getApply(S));
}
export function chain(M, S) {
    const _left = left(M);
    return (f) => (ma) => pipe(ma, M.chain(T.match(_left, f, (e1, a) => pipe(f(a), M.map(T.match((e2) => T.left(S.concat(e2)(e1)), (b) => T.both(e1, b), (e2, b) => T.both(S.concat(e2)(e1), b)))))));
}
export function bimap(F) {
    return flow(T.bimap, F.map);
}
export function mapLeft(F) {
    return (f) => F.map(T.mapLeft(f));
}
export function match(F) {
    return flow(T.match, F.map);
}
export function matchE(M) {
    return flow(T.match, M.chain);
}
export function swap(F) {
    return F.map(T.swap);
}
export function toTuple2(F) {
    return flow(T.toTuple2, F.map);
}
