/**
 * A `BoundedDistributiveLattice` is a lattice that is both bounded and distributive
 *
 * @since 3.0.0
 */
import type { BoundedLattice } from './BoundedLattice'
import { DistributiveLattice } from './DistributiveLattice'
import type { Ord } from './Ord'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface BoundedDistributiveLattice<A> extends BoundedLattice<A>, DistributiveLattice<A> {}
/**
 * @category constructors
 * @since 3.0.0
 */
export declare const getMinMaxBoundedDistributiveLattice: <A>(
  O: Ord<A>
) => (min: A, max: A) => BoundedDistributiveLattice<A>
