/**
 * @since 3.0.0
 */
import type { Ring } from './Ring'
import type { Eq } from './Eq'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface Field<A> extends Ring<A> {
  readonly degree: (a: A) => number
  readonly div: (second: A) => (first: A) => A
  readonly mod: (second: A) => (first: A) => A
}
/**
 * The *greatest common divisor* of two values.
 *
 * @since 3.0.0
 */
export declare const gcd: <A>(E: Eq<A>, F: Field<A>) => (second: A) => (first: A) => A
/**
 * The *least common multiple* of two values.
 *
 * @since 3.0.0
 */
export declare const lcm: <A>(E: Eq<A>, F: Field<A>) => (second: A) => (first: A) => A
