/**
 * Data structure which represents non-empty **mutable** arrays.
 *
 * This module is mainly useful while implementing features for `ReadonlyArray` and `ReadonlyNonEmptyArray`.
 *
 * @since 3.0.0
 */
import type { ReadonlyNonEmptyArray } from './ReadonlyNonEmptyArray'
/**
 * @category model
 * @since 3.0.0
 */
export interface NonEmptyArray<A> extends Array<A> {
  0: A
}
/**
 * @category constructors
 * @since 3.0.0
 */
export declare const fromReadonlyNonEmptyArray: <A>(as: ReadonlyNonEmptyArray<A>) => NonEmptyArray<A>
