/**
 * @since 3.0.0
 */
import type { Contravariant1 } from './Contravariant'
import type { Monoid } from './Monoid'
import type { Semigroup } from './Semigroup'
/**
 * @since 3.0.0
 */
export interface Predicate<A> {
  (a: A): boolean
}
/**
 * @category Contravariant
 * @since 3.0.0
 */
export declare const contramap: Contravariant1<URI>['contramap']
/**
 * @category instances
 * @since 3.0.0
 */
export declare type URI = 'Predicate'
declare module './HKT' {
  interface URItoKind<A> {
    readonly Predicate: Predicate<A>
  }
}
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAny: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAny: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAll: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAll: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Contravariant: Contravariant1<URI>
/**
 * @since 3.0.0
 */
export declare const not: <A>(predicate: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const or: <A>(second: Predicate<A>) => (first: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const and: <A>(second: Predicate<A>) => (first: Predicate<A>) => Predicate<A>
