/**
 * @category type classes
 * @since 3.0.0
 */
export interface Show<A> {
  readonly show: (a: A) => string
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const struct: <A>(shows: { [K in keyof A]: Show<A[K]> }) => Show<{ readonly [K_1 in keyof A]: A[K_1] }>
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const tuple: <A extends readonly unknown[]>(
  ...shows: { [K in keyof A]: Show<A[K]> }
) => Show<Readonly<A>>
